package com.ademicon.service;

import java.io.UnsupportedEncodingException;
import java.util.Base64;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.NoSuchProviderException;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import com.ademicon.model.Email;

public class EmailService {

    final String username = "prosegnews@conseg.com.br";
    final String password = "Ademicon#2024";

    public void sendmail(Email email) throws MessagingException, UnsupportedEncodingException {

        System.out.println("ACESSOU SERVIÇO");

        Properties props = new Properties();
        props.setProperty("mail.smtp.starttls.enable", "true");
        props.setProperty("mail.smtp.auth", "true");
        props.setProperty("mail.smtp.starttls.enable", "true");
        props.setProperty("mail.smtp.host", "smtp.office365.com");
        props.setProperty("mail.smtp.port", "587");
        props.setProperty("mail.smtp.ssl.trust", "smtp.office365.com");

        System.out.println("EMAIL DEFINIU PROPRIEDADES");

        Session session = Session.getInstance(props,
                new javax.mail.Authenticator() {
                    protected PasswordAuthentication getPasswordAuthentication() {
                        return new PasswordAuthentication(username, password);
                    }
                });

        System.out.println("EMAIL AUTENTICOU");

        Transport transport = session.getTransport();

        System.out.println("EMAIL TRANSPORTE");

        try {

            Message message = new MimeMessage(session);
            MimeBodyPart messageBodyPart = new MimeBodyPart();
            MimeMultipart multipart = new MimeMultipart("mixed");

            // Define o e-mail e nome do remetente
            message.setFrom(new javax.mail.internet.InternetAddress("prosegnews@conseg.com.br", "Ademicon"));

            // Seta o assunto do e-mail
            message.setSubject(email.getSubject());

            // Adiciona o destinatário principal
            message.addRecipient(
                    javax.mail.Message.RecipientType.TO,
                    new javax.mail.internet.InternetAddress(email.getTo()));

            // Seta os destinatários que receberão uma cópia do e-mail
            if (!email.getCc().isEmpty()) {
                List<String> c = email.getCc();
                for (String cString : c) {
                    message.addRecipient(
                            javax.mail.Message.RecipientType.CC,
                            new javax.mail.internet.InternetAddress(cString));

                }
            }

            // Seta os destinatários que receberão uma cópia oculta
            if (!email.getCco().isEmpty()) {
                List<String> cco = email.getCco();
                for (String c : cco) {
                    message.addRecipient(
                            javax.mail.Message.RecipientType.BCC,
                            new javax.mail.internet.InternetAddress(c));

                }
            }

            // Seta o conteúdo do corpo do e-mail e sua codificação
            if (!email.getTemplate().isEmpty()) {
                byte[] decodedBytes = Base64.getDecoder().decode(email.getTemplate());
                String template = new String(decodedBytes);
                messageBodyPart.setContent(template, "text/html; charset=utf-8");
            } else {
                messageBodyPart.setContent(email.getMessage(), "text/plain; charset=utf-8");
            }

            // Adiciona os anexos que serão enviados no e-mail
            if (!email.getAttachments().isEmpty()) {
                Map<String, String> attachments = email.getAttachments();
                for (Map.Entry<String, String> set : attachments.entrySet()) {
                    var byteArray = java.util.Base64.getDecoder().decode(new String(set.getValue()));
                    var attachment = new javax.mail.internet.MimeBodyPart();
                    attachment.setDataHandler(new javax.activation.DataHandler(
                            new javax.mail.util.ByteArrayDataSource(byteArray, "application/octet-stream")));
                    attachment.setDisposition(javax.mail.internet.MimeBodyPart.ATTACHMENT);
                    attachment.setFileName(set.getKey());
                    multipart.addBodyPart(attachment);

                }
            }

            multipart.addBodyPart(messageBodyPart);
            message.setContent(multipart);

            // Método para se autenticar ao servidor
            System.out.println("INICIARA A CONEXÃO");
            transport.connect();
            System.out.println("FINALIZOU A CONEXÃO");

            // Método para enviar a mensagem criada
            System.out.println("Sending");
            transport.sendMessage(message, message.getAllRecipients());
            System.out.println("Done");

        } catch (NoSuchProviderException e) {
            System.out.println("ERRO NoSuchProviderException");
            System.out.println(e);
            e.printStackTrace();
            throw e;

        } catch (MessagingException e) {
            System.out.println("ERRO MessagingException");
            System.out.println(e);
            e.printStackTrace();
            throw e;

        } catch (UnsupportedEncodingException e) {
            System.out.println("ERRO UnsupportedEncodingException");
            System.out.println(e);
            e.printStackTrace();
            throw e;

        } finally {
            transport.close();
        }

    }

}
